//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <string>
#include "Queue.hpp"      //    

#include <conio.h>   //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{

 try {    
    Queue<string> q;

    //     
    q.push(ToRus(" "));
    q.push(ToRus(". "));
    q.push(ToRus(""));

    //       
    cout << ToRus("      : \n");
    cout << q.pop();
    cout << q.pop();
    cout << endl;

    //    
    q.push(ToRus(" "));
    q.push(ToRus("!"));

    //   
    q.pop();

    //       
    cout << ToRus("    : \n");
    cout << q.pop();
    cout << q.pop() << endl;

    //    
    cout << ToRus("   : ") << q.size()
         << endl;
    //     
    cout << q.pop() << endl;
   }
   catch (const exception& e) {
      cerr << "EXCEPTION: " << e.what() << endl;
   }


  getch();
  return 0;
}

//---------------------------------------------------------------------------